Runtime Property Definition

Option | Description
fileStatus02AsIBMCobol= | Controls when to set file status 02. Valid values are: STANDARD or S – File status 02 is set after a successful read using an alternative index and the current key is not unique. a successful write or rewrite resulted in duplicate entries in one or more alternative indexes. COMPAT or C – File status 02 is set as for STANDARD, except for read of files with access mode random and opened for I/O. In such cases, file status 00 is returned instead of file status 02. This option is similar to how IBM COBOL handles such situations. The default value is STANDARD.
jopaz.abend.cc= | Configures the completion code for user abends. The default value is 1.
jopaz.abend.enabled= | Configures how Jopaz handles system errors. Valid values are: 0 – Exits the program with return code 255. 1 – Terminates the program with a user abend. Use this to achieve a behavior comparable to IBM COBOL. The default value is 1. Note: The default value for earlier versions was 0.
jopaz.array_check= | Checks array boundaries. Valid values are: -1 – Array boundaries are checked at runtime in order to provide more details in case "out of bounds" errors exist. When a program addresses an item that is outside the valid range, an error message is written to the log if you have set jopaz.tracelevel to a value greater than zero. The error message informs about the data item name and the problematic index value. 0 – Array boundaries are not checked. If a program addresses an item that is outside the valid range, a generic "out of bounds" error message is shown and the program exits. The -m1 option may avoid the crash and force the program to access the area of the next Working-Storage item instead. This corresponds to the IBM COBOL compiler option NOSSRANGE. 1 – Array boundaries are checked at runtime in order to provide more details in case "out of bounds" errors exist. If a program addresses an item that is outside the valid range, an error message is shown and the program exits. The error message informs about the data item name and the problematic index value. This corresponds to the IBM COBOL compiler option SSRANGE. The default value is 0.
jopaz.checkdiv= | Allows you to specify an alternate runtime response to a divide by zero condition when the statement does not include a ON SIZE ERROR clause. Valid values are: -1 – The error message "Attempt to divide by zero" is written to the log and the program aborts. jopaz.tracelevel must be set to a value greater than zero. 0 – Results are undefined. 1 – The program aborts with the error message "Attempt to divide by zero". 2 – The result is zero. 3 – The result is the dividend, as if the division was by 1 instead of by zero. The default value is 0.
jopaz.cpu_statistics= | Enables the Jopaz CPU statistics for runtime. Valid values are: 1 – Enable the tracing for CPU statistics, 0 – Disable the tracing for CPU statistics. With the DD card JPZPRINT the CPU statistics can be written either to a separate job class or to a physical file. Otherwise the statistics are written in the JES Job Log (JESMSGLG).
jopaz.debug.port= | Specifies the port used by the remote debugger. This can be used in the Framework configuration to tell which port it should listen to connect instead of passing this information on the command line. The default value is 9999.
jopaz.display_message= | Defines how messages are shown to the user. This affects both messages displayed by the program through the DISPLAY MESSAGE BOX statement and error messages shown by the runtime system. Valid values are: 0 – All messages are shown in a message box. 1 – All messages are sent to sysout. 2 – All messages are sent to syserr. 3 – Messages displayed by the program are sent to syserr. Runtime error messages are printed to a file named <program_name><number>.ads.log, where <number> is a progressive number calculated by the runtime. The file name and location can be customized with the jopaz.exception.dumpfile property. Any other value is equivalent to 2.The default value is 0. The recommended value is 2.
jopaz.exception.dump= | Defines whether to produce an Abend Diagnostic Snapshot (ADS) or not. Valid values are: 1 – Produces ADS in addition to Java exceptions. 0 – Does not produce ADS. The default value is 0.
jopaz.exception.dumpfile=pathname | Specifies the pathname of the file generated when setting jopaz.display_message=3 or jopaz.exception.message=3. The following special characters are supported in the value of this property: %p – program name %d – current date in the form YYYYMMDD %t – current time in the form HHMMSSTTT %u – username %h – hostname. If the value begins with a ”+” character, the report is appended to the specified file, otherwise the new report overwrites the specified file. For example: jopaz.exception.dumpfile=/tmp/%p.dump If this property is not set, a file named <program_name><number>.ads.log, where <number> is a progressive number calculated by the runtime, is generated by default in the working directory.
jopaz.exception.java= | Specifies the content of the exception messages. Valid values are: 1 – Internal java methods are traced in exception messages. 0 – COBOL paragraph names are traced in exception messages. The default value is 0.
jopaz.exception.message= | Defines how exception messages are shown to the user. This affects only error messages shown by the runtime system. Valid values are: 0 – The messages are shown in a message box. 1 – The messages are sent to sysout. 2 – The messages are sent to syserr. 3 – The messages are printed to a file named <program_name><number>.ads.log, where <number> is a progressive number calculated by the runtime. The file name and location can be customized with the jopaz.exception.dumpfile property. Any other value is equivalent to 2. The default value is 0. The recommended value is 2.
jopaz.file.close_on_exit= | Specifies open files to close at program exit. Valid values are: 1 – All open files are closed when the program exits. 0 – Open files are left open when the program exits. The default value is 0.
jopaz.file.errors_ok= | Configures how I/O errors are treated. Valid values are: 0 – The program stops if an error occurs and there are no declaratives. 1 – The program continues even if an errors occurs. 2 – The program continues when an error occurs only if a status is defined for the file. The default value is 0.
jopaz.gui.show_zeroes= | Specifies whether leading zeros are shown when displaying numeric data. This property affects all the output devices: console, character-based terminals, and graphical windows. Valid values are: 1 – Leading zeroes are shown when displaying numeric data. 0 – Leading zeroes are not shown when displaying numeric data The default value is 0.
jopaz.logfile=pathname | Specifies the path of the log file. Backslashes must be doubled. The Jopaz framework uses the java.util.logging package and there are many configuration options. For example, you can specify %h in the jopaz.logfile and it will be replaced by the user’s home directory. You can specify %yyyy, %mm, %dd, %hh, %nn, %ss, and %cc and they will be replaced with the current year, month, day, hour, minute, second, and hundredth of second respectively. You can specify a %u in the iscobol.logfile and it will be replaced with a unique number at runtime to resolve conflicts.
jopaz.logfile.elapse_time=seconds | Sets the amount of time, in milliseconds, for which the runtime is logged. This allows you to write to a log file for a specific period of time.
jopaz.print_version= | Prints the Jopaz version information to STDOUT before running the main program. Valid values are: 0 – Disable. 1 – Enable. The default value is 0.
jopaz.process.aixbld= | Generates VSAM alternative indexes at runtime. Note: The index for subsequent use must be reusable. You must also have the index and path already defined. Valid values are: ON or YES – Builds alternative indexes at open. OFF or NO– Does not build alternative indexes. The default value is OFF.
jopaz.process.cblqda= | Activates the QSAM Dynamic Allocation option. This option controls how Jopaz behaves when opening a QSAM file that neither has a DD statement, nor an environment variable for allocation. The file must be opened for output or the file must be optional and opened for extend or I/O. Valid values are: ON – Allocates a temporary dataset, which is deleted at end of the run unit. OFF – Fails to open with file status 96. The default value is OFF.
jopaz.process.dumpOnOpen= | Diagnostic option. Valid values are: * – A formatted dump of the I/O class is performed immediately after opening any file. "ddnames" – A formatted dump of the I/O class is performed immediately after opening a file referred to by "ddnames". "ddnames" is a list of DD names separated by one of the following separators: ,, ., ;, :. Example: jopaz.process.dumpOnOpen=myinput,myoutput;mywork. The default value is "".
jopaz.process.ignoreLreclForU= | Controls the record format undefined and logical record length option. This option controls how Jopaz behaves when comparing attributes on opening datasets with record format U. When opening such a dataset for writing, Jopaz always sets LRECL=0. Valid values are: ON or YES – Logical record length is not checked. Sets LRECL=0. OFF or NO– Logical record length is checked before opening and fails if it encounters differences. The default value is ON.
jopaz.process.noadvopt= | Affects files with compiler option -noadv. This option only concerns files defined with the linage clause. Valid values are: S or STANDARD – Compiler option -noadv has no effect on files defined with the linage clause. C or COMPAT– Overwrites the first character with a printer control character and sets the last character to low value. This option is similar to how IBM COBOL handles such situations. The default value is STANDARD.
jopaz.process.showIOerrors= | Diagnostic option controlling how exceptions and arguments are handled. Valid values are: ON or YES – IO exceptions and open arguments are printed to stderr. OFF or NO – IO exceptions and open arguments are not shown. The default value is OFF.
jopaz.process.showIOjar= | Displays jar name for diagnostic purposes. Valid values are: ON or YES – The I/O module displays from which jar it is loaded. OFF or NO – Does not display jar name. The default value is OFF.
jopaz.process.usezfile= | Forces usage of ZFile. The I/O module chooses the most performant way of doing I/O. For diagnostic reasons it might be an advantage to use ZFile instead. Valid values are: ON or YES – All I/O goes through ZFile. OFF or NO – The I/O module decides if to use ZFile or not. The default value is OFF.
jopaz.process.vlr= | Controls the Variable Length Record option. This option is consistent with the COBOL 6 compiler option VLR. Valid values are: S or STANDARD – File status 04 follows the rules of COBOL 6. File status 04 is set if the record size is less or larger than the level 01 size. C or COMPAT– File status 04 follows the rules of COBOL 4. File status 04 is set for record sizes outside the ”varying in size from int-1 to int-2 ” clause in the FD. The default value is STANDARD.
jopaz.process.vsamLongRecord= | Controls what action to take when reading a VSAM record with a length longer than the record definition. Valid values are: CUTOFF – Records longer than the record definition are cut off, file status 04 is set and the record length field is set to record definition length + 1. ERROR – Records longer than the record definition return file status 92. The default value is ERROR.
jopaz.process.vsamopenfs= | Controls the VSAM Open File Status. This option is similar to the IBM COBOL compiler option VSAMOPENFS. Valid values are: C or COMPAT – File status is set to 97 after a successful open output/ I/O of a VSAM file that required a file integrity check. Note: Using COMPAT might affect performance. S or SUCC or STANDARD – File status is set to zero even when the file required an integrity check. The default value is COMPAT.
jopaz.rundebug= | Specifies how the runtime interacts with the remote debuggers. Valid values are: 0 – Remote debugging is not possible. 1 – The first program will start and run immediately. The remote debug session waits and listens for a program that is compiled for debugging to launch connecting to the program when it detects it. This is useful when you want to debug only some of your application’s programs. 2 – The runtime framework will start in debug mode pausing to connect to a remote debugger before running the program. This is useful when all your programs are compiled for debugging and you want to start your remote debugger at the very first line of the application. The default value is 0. Note: This runtime property is used also by the compiler to let you debug preprocessor programs, if these programs are written in COBOL, through the remote debugger.
jopaz.sqlj.get_diagnostics= | Specifies the behavior that is applied for the GET DIAGNOSTICS statement during runtime. Valid values are: 0 – Returns with an internal error and stops execution. 1 – The GET DIAGNOSTICS function is not executed. A warning message is issued, and program execution continues. 2 – The GET DIAGNOSTICS function is not executed. An info message is displayed later, and DSNTIAR is called.
jopaz.trace_location= | Specifies where to output the tracing information. Note: Set this property only if you set the trace level property jopaz.tracelevel=. Valid values are: 1 – Activates the writing of the tracing information into the job class STDOUT when the runtime job is executed. 2 – Activates the writing of the tracing information into a UNIX file under the path specified in the runtime property jopaz.logfile=. 3 – Combines option one and two. The default value is 1.
jopaz.tracelevel= | Allows the user to define the events to be traced. Valid values are: 3 – Includes config settings and program starts and ends. 7 – Includes config, program starts/ends, and paragraph starts/ends. 11 – Includes config, program starts/ends, and file input/output. 15 – Includes config, program and paragraph starts/ends, and file i/o. 43 – Includes config, program starts/ends, and file input/output plus the content of read records. 63 – Traces everything of the above. 256 – Traces SQL activity. The default value is 0.
ussFilesAlwaysExtend= | z/OS Unix file system open option for record files. Controls the behavior of open output for files located in the Unix file system and for file organization that is either fixed or variable length record. Valid values are: Y or YES – Open output works as open extend regardless of dispositions in the JCL. This option is similar to how IBM COBOL handles such situations. N or NO – Open output overwrites the file unless PATHOPTS in the JCL specifies OAPPEND. The default value is NO.